import Image
import ImageStat
import ImageOps
import ImageChops

def load(sName1,sName2):
    I1=Image.open(sName1)
    I2=Image.open(sName2)
    return (I1,I2)

def find_match(I1,I2):
    I1g=I1.convert("L")
    I2g=I2.convert("L")
    # The big cheat - I know this point is distinctive
    sliceI2=I2g.crop((110,150,135,300))
    (width,height)=I1g.size
    # search I1 for point that is most similiar to the slice
    # We use a crude differing + variation approach as PIL doesn't have good
    # correlation options
    best=999999
    best_x=0
    best_y=0
    # This is just a performance hack - it will work over much larger
    # search areas, just very slowly
    for x in range(460,550):
        for y in range(140,180):
            # The small cheat - this is an easy problem, so I don't need to
            # worry about rotation & scale, which are issues in the general
            # case
            sliceI1=I1g.crop((x,y,x+25,y+150))
            It=ImageChops.difference(sliceI1,sliceI2)
            Istats=ImageStat.Stat(It)
            sum=Istats._getvar()[0]
            if sum<best:
                best=sum
                best_x=x
                best_y=y
    return (best_x-110,best_y-150)

def combine(I1,I2,pos):
    # pos is the x,y position of ((0,0) in I2) in I1
    # We assume only 2 images that are "similiar" views of the scene, so
    # no need for complex rectification.
    Inew=ImageOps.expand(I1.crop((0,0,x,I1.size[1])),(0,0,I2.size[0],y))
    I1part1=I1.crop(pos+I1.size)
    # works because I2.size==I1.size
    I2part2=I2.crop((I2.size[0]-x,0,I2.size[0],I2.size[1]))
    I2part1=I2.crop((0,0,I2.size[0]-x,I2.size[1]-y))
    Inew.paste(I2part2,box=(I1.size[0],y,Inew.size[0],Inew.size[1]))
    Imask=I1part1.convert("L")
    for xx in range(Imask.size[0]):
        cur=255*xx/Imask.size[0]
        for yy in range(Imask.size[1]):
            Imask.putpixel((xx,yy),cur)
    Imid=Image.composite(I2part1,I1part1,Imask)
    Inew.paste(Imid,box=(x,y,Imask.size[0]+x,Imask.size[1]+y))
    return Inew

(I1,I2)=load( '../Images/t1.jpg', '../Images/t2.jpg')
I1.show(command='display')
I2.show(command='display')
(x,y)=find_match(I1,I2)
I3=combine(I1,I2,(x,y))
I3.show(command='display')


